import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import java.awt.Color;

/**
 * This class implements the user interface.
 */
public class ColorWindow extends JFrame {
	
	private JColorChooser colorChooser;
	private Timer t;
	private int minValue = 0;
	private int maxValue = 1000;
	private double hue = 0.0;
	private double saturation = 1.0;
	private double brightness = 1.0;
	SensorInterface sensor;
	
	public ColorWindow() throws Exception {
		// I sort of dislike Java... if you want to fix up the interface so it looks
		// and works nicer, go for it!
		super("CSE 466 Color Window");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		colorChooser = new JColorChooser();
		BoxLayout layout = new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS);
		this.getContentPane().setLayout(layout);
		this.getContentPane().add(colorChooser);
		
		// Buttons to capture minimum and maximum values
		JButton setMinBtn = new JButton("Set Minimum Value");
		this.getContentPane().add(setMinBtn);
		JButton setMaxBtn = new JButton("Set Maximum Value");
		this.getContentPane().add(setMaxBtn);
		
		this.pack();
		this.setVisible(true);
		sensor = new SensorInterface();
		
		setMinBtn.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				minValue = sensor.readSensor();
				System.out.println("Set minimum value to " + minValue);
			}
		});
		
		setMaxBtn.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				maxValue = sensor.readSensor();
				System.out.println("Set maximum value to " + maxValue);
			}
		});
		
		t = new Timer(50, new ActionListener() { 
			public void actionPerformed(ActionEvent e) {
				// Do timer stuff here
				int mag = sensor.readSensor();
				double value = (double)(mag - minValue) / (maxValue - minValue);
				hue = 1.0 - value;
				Color c = Color.getHSBColor((float)hue, (float)saturation, (float)brightness);
				colorChooser.setColor(c);
				sensor.setLEDColor(c.getRed(), c.getGreen(), c.getBlue());
			}
		});
		t.start();
		
		
		
	}
	
	public static void main(String[] args) throws Exception {
		ColorWindow c = new ColorWindow();
	}
	
}